Subject: [Diffserv] comments from Dave Perkins regarding RowPointers

From: Fred Baker <[email-masked]>
Date: Wed, 26 Sep 2001 10:38:25 -0700

Dave Perkins sent a note to the authors of the MIB with a set of comments. 
Many of them are at a nit level, and will be handled directly. This, 
however, calls for some working group comment.

>6) With use of pointers it is useful to have "reference
>    counts". There are none in the MIB module, and it
>    is not strictly necessary since a management application
>    can (and most likely will) compute them. This such
>    be pointed out somewhere in the text of the document.

I can solve this two ways:
  - I can add a usage counter to each of the tables, which when non-zero 
suggests
    that the wise network manager will not delete the given row, or
  - I can put a comment into the text that says that a network manager 
using this
    for configuration should implement such a counter internally.

The latter may be interesting in a multimanager sense; before deleting 
anything,  manager should get-bulk the entire MIB and recheck its counters, 
in case someone else has done something amusing. On the other hand, I can't 
think of very many MIBs that implement usage counters.

Thoughts?

_______________________________________________
diffserv mailing list
[email-masked]
https://www1.ietf.org/mailman/listinfo/diffserv
Archive: http://www2.ietf.org/mail-archive/working-groups/diffserv/current/maillist.html

---

From: Juergen Schoenwaelder <[email-masked]>
Date: Thu, 27 Sep 2001 10:38:16 +0200

>>>>> Fred Baker writes:

[...]

Fred> I can solve this two ways: - I can add a usage counter to each
Fred> of the tables, which when non-zero suggests that the wise
Fred> network manager will not delete the given row, or - I can put a
Fred> comment into the text that says that a network manager using
Fred> this for configuration should implement such a counter
Fred> internally.

Fred> The latter may be interesting in a multimanager sense; before
Fred> deleting anything, manager should get-bulk the entire MIB and
Fred> recheck its counters, in case someone else has done something
Fred> amusing.

This won't work since someone still can modify the MIB while you
retrieve and process it.

I think there is another option: Require that the agent keeps
reference counters internally and that requests to destroy rows will
result in an error if there are still pointers to this row. This means
that managers only need to check the whole MIB when there really is a
conflict to be resolved. Of course, managers need to use an
intelligent strategy to destroy rows and you probably also want to
make sure that the agent does not allow circular dependencies (not
sure the current MIB allows that or not).

/js

---

From: Fred Baker <[email-masked]>
Date: Thu, 27 Sep 2001 03:10:27 -0700

At 01:38 AM 9/27/2001, Juergen Schoenwaelder wrote:
>result in an error if there are still pointers to this row.

In that case, one could argue that we are changing the RowStatus variable. 
I think you have a good idea here, but I suspect that it requires noting 
that in the DESCRIPTION.